public class GreenChannelFilter implements PixelFilter, ParameterizedFilter {
	private final BooleanFilterParam grayscaleParam =
		new BooleanFilterParam("Grayscale", true);
	
	private final FilterParam[] params = new FilterParam[] {
		grayscaleParam
	};
	
	// ### FILTER ###
	
	public int filter(int pixel) {
		boolean grayscale = grayscaleParam.getValue();
		
		int intensity = Pixels.getGreen(pixel);
		return Pixels.packPixel(
			Pixels.getAlpha(pixel),
			grayscale ? intensity : 0,
			intensity,
			grayscale ? intensity : 0);
	}
	
	public String toString() {
		return "RGB Channel (Green)";
	}
	
	// ### PARAMETERIZED FILTER ###
	
	public FilterParam[] getParams() {
		return params;
	}
}